RandomPetConfig_defaultSuppressBanner = false;
RandomPetConfig_defaultZoneOffset = 150
RandomPetConfig_defaultzonemessage = RND_ACTIVATEPET
RandomPetConfig_defaultPetSwapCount = 2
RandomPetConfig_defaultPetSwap = false;
NO_PET = "No Pet" -- DO NOT LOCALIZE THIS VALUE
RandomPetCurrentPetName = NO_PET;  -- The current pet that is out
RandomPetConfig_defaultAlwaysSwitch = false;
---------
function Rnd_OnLoad()
---------
	SlashCmdList["RANDOMPET"] = function(msg) Rnd_Slash(msg) end
	SLASH_RANDOMPET1 = "/randompet"
	SlashCmdList["RNDPET"] = function(msg) Rnd_Slash(msg) end
	SLASH_RANDOMPET2 = "/rndpet"
	this:RegisterEvent("VARIABLES_LOADED")
	this:RegisterEvent("PLAYER_LOGIN")
	
	this:RegisterEvent("PLAYER_ENTERING_WORLD");   

  this:RegisterEvent("PLAYER_ALIVE");
  
  -- For pet swaps at bank, swap up to X pets in inventory
  this:RegisterEvent("BANKFRAME_OPENED");
  
	
	Rnd_Msg(RND_LOADED)
	
	-- debug
	--local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo("Jingling Bell");
--	PrintItemID(sLink);
end --function


function PrintItemID(itemstring)
		local idstart, idend = string.find(itemstring,"item:(%d+):(%d+):(%d+):(%d+)");
		local itemid = string.sub(itemstring,idstart,idend);
Rnd_Msg(itemid);
end

function IntializePetVariables()
  if (not RandomPetConfig ) then
     RandomPetConfig = {};
  end
  
  if (not RandomPetConfig.suppress) then
  	RandomPetConfig.suppress = RandomPetConfig_defaultSuppressBanner
  	Rnd_Msg(RND_USINGDEFAULTBANNER)
  elseif
  	RandomPetConfig.suppress == true then
  	Rnd_Msg(RND_SUPPRESSINGBANNER)
  else
  	Rnd_Msg(RND_USINGDEFAULTBANNER)
  end
  
  if (not RandomPetConfig.zoneoffset) then
 	 RandomPetConfig.zoneoffset = RandomPetConfig_defaultZoneOffset
  end
  
  if (not RandomPetConfig.zonemessage) then
 	 RandomPetConfig.zonemessage = RandomPetConfig_defaultzonemessage
	end
  
  if (not RandomPetConfig.PetSwapCount) then
  	RandomPetConfig.PetSwapCount = RandomPetConfig_defaultPetSwapCount
	end
	
	if (not RandomPetConfig.PetSwap) then
		RandomPetConfig.PetSwap = RandomPetConfig_defaultPetSwap
	end
	
  --RandomPetConfig.PetSwap = RandomPetConfig_defaultPetSwap
end

function BankSwap()
  
  -- now we have to tables, 1 with pets to take from bank
  -- the other is a table with pets to put in the bank
  
--  local bpet2 = pets[math.random(table.getn(bankpets))]
  
  
--  local mypets = Rnd_ScanForPets(Rnd_Pets)
--  if mypets then
--  local mpet1 = pets[math.random(table.getn(mypets))]
--  local mpet2 = pets[math.random(table.getn(mypets))]
--	end
  -- swap pets
  
  -- need to find bank slots of bpet1,bpet2
  -- need to find inventory slots of mpet1, mpet2
  -- need to be sure that we have space to do the swap
  
  --PickupContainerItem(mpet1)
  --PickupContainerItem(mpet2)
  --PickupContainerItem(bpet1)
  --PickupContainerItem(bpet2)

  	--Rnd_Msg("Swapping Pets at Bank")
  --end -- if bankpets
end

---------
function Rnd_ScanForPetsBank(list)
---------
	local Pets = {}
	if table.getn(list) > 0 then
		local level = UnitLevel("player")
		for i, item in ipairs(list) do
			local name, bag, slot = Rnd_FindInBank(item, level)
			if name then
				table.insert(Pets, {type = "item", item = name})
			end --if
		end --for
	end --if

	if table.getn(Pets) > 0 then
		return Pets
	else
	   return nil
			
	end --if
end --function


---------
function Rnd_OnEvent(event)
---------
	if event == "BANKFRAME_OPENED" then
	  BankSwap()
  end
	
	if event == "VARIABLES_LOADED" then
		IntializePetVariables()
	end
	
	if event == "PLAYER_LOGIN" then
	
		Rnd_HijackBindings(event)
		RandomPetCurrentPetName = NO_PET;
	end
	
	if event == "PLAYER_ENTERING_WORLD" then
	  RandomPetCurrentPetName = NO_PET;
	  if RandomPetConfig.suppress ==false then
	  Rnd_CenterMsg(RandomPetConfig.zonemessage)
	  
	  end -- if
	end -- if (ev
	
	if event == "PLAYER_ALIVE" then
	RandomPetCurrentPetName = NO_PET;
	if RandomPetConfig.suppress==false then
	  Rnd_CenterMsg(RandomPetConfig.zonemessage)	  
	  end -- if (RND
	end -- if (even
	
end --function

---------
function Rnd_Slash(msg)
---------
if msg == "noalert" then
  RandomPetConfig.suppress = true
  Rnd_Msg(RND_ALERTOFF)
  -- save options
  return;
end -- if

if msg == "showalert" then
  RandomPetConfig.suppress = false
  Rnd_Msg(RND_ALERTON)
  -- save options
  return;
end -- if


if msg == "default" then
    -- save options
    RandomPetConfig.suppress = RandomPetConfig_defaultSuppressBanner
    RandomPetConfig.zoneoffset = RandomPetConfig_defaultZoneOffset
    RandomPetConfig.zonemessage = RandomPetConfig_defaultzonemessage
    Rnd_Msg(RND_DEFAULT)
    return
end -- if

if msg == "options" then
   RND_Config:Show();
   return
end

if msg == "nopet" then
  RandomPetCurrentPetName = NO_PET;
  return;
end

    Rnd_Msg(RND_OPTIONS1)
    Rnd_Msg(RND_OPTIONS2)			
    Rnd_Msg(RND_OPTIONS3)
    Rnd_Msg(RND_OPTIONS4)
    Rnd_Msg(RND_OPTIONS5)
    Rnd_Msg(RND_OPTIONS6)
    Rnd_Msg(RND_OPTIONS7)
end --function


---------
function Rnd_CenterMsg(msg)
---------
  
  RndPetTextFrameText:ClearAllPoints();
  RndPetTextFrameText:SetPoint("TOP","UIParent",0,RandomPetConfig.zoneoffset * -1 );
	RndPetTextFrameText:SetTextColor(0.1, 1.0, 0.55);
        	RndPetTextFrameText:SetText(msg);
        	RndPetTextFrame.startTime = GetTime();
        	RndPetTextFrame:Show();
end

---------
function Rnd_Msg(msg)
---------
	if msg then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e000RandomPet: |r"..msg)
	end --if
end --function

---------
function Rnd_PreClick()
---------
		local Pet = Rnd_ChoosePet(Rnd_Pets)
		if Pet then
	--	Rnd_Msg(Pet.item);
	--	Rnd_Msg("CPet="..RandomPetCurrentPetName) 
		--if string.find(Pet.item,RandomPetCurrentPetName) ~= nil then 	
		if Pet.item ~= RandomPetCurrentPetName then
		--      Rnd_Msg("Not Equal");
		  	  RandomPetCurrentPetName = Pet.item
					Rnd_FillButton(Pet)			 					
					Rnd_Msg(RND_SAYACTION)
				else
				  ClearButton()
					Rnd_Msg(RND_PETISOUT)
			  end  -- if pet.item
		else
		  Rnd_Msg(RND_NOPETS)
		end --if pet
end --function

---------
function Rnd_ChoosePet(scanfor)
---------
	local Pets = Rnd_ScanForPets(scanfor)
	if Pets then
		return Pets[math.random(table.getn(Pets))]
	end --if
end --function

---------
function Rnd_ScanForPets(list)
---------
	local Pets = {}
	if table.getn(list) > 0 then
		local level = UnitLevel("player")
		for i, item in ipairs(list) do
			local name, bag, slot = Rnd_FindInBags(item, level)
			if name then
				table.insert(Pets, {type = "item", item = name})
			end --if
		end --for
	end --if

	if table.getn(Pets) > 0 then
		return Pets
	else
	   return nil
			
	end --if
end --function

---------
function Rnd_FindInBags(item, level)
---------
	for bag = 0, NUM_BAG_FRAMES do
		for slot = 1, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if link and string.find(link, item) then
				local name, _, _, _, minlevel = GetItemInfo(link)
				if minlevel <= (level or 70) then
					return name, bag, slot
				end --if
			end --if
		end --for
	end --for
end --function

---------
function Rnd_FindInBank(item, level)
---------
	for bag = 0, NUM_BAG_FRAMES do
		for slot = 1, GetContainerNumSlots(bag) do
			local link = GetContainerItemLink(bag, slot)
			if link and string.find(link, item) then
				local name, _, _, _, minlevel = GetItemInfo(link)
				if minlevel <= (level or 70) then
					return name, bag, slot
				end --if
			end --if
		end --for
	end --for
end --function

---------
function Rnd_HijackBindings(event)
---------
	local key1, key2 = GetBindingKey("RANDOMPETBINDING")
	if key1 then
		SetBindingClick(key1, "Rnd_Button")
	end --if
	if key2 then
		SetBindingClick(key2, "Rnd_Button")
	end --if
	if not event and (key1 or key2) then
		Rnd_Msg(RND_HIJACK)
	end --if
end --function

function ClearButton()
  CloseMerchant()
	local attributes = {"type", "spell", "item"}
	for i, attribute in ipairs(attributes) do
		Rnd_Button:SetAttribute(attribute, nil)
	end --for
end

---------
function Rnd_FillButton(Pet)
---------
  --Rnd_Msg("Selecting Pet");
	Pet = Pet or {}
	CloseMerchant()
	local attributes = {"type", "spell", "item"}
	for i, attribute in ipairs(attributes) do
		Rnd_Button:SetAttribute(attribute, Pet[attribute])
	end --for
end --function


---------
function Rnd_Id(itemstring)
---------
	local _, _, itemid = string.find(itemstring,"(item:%d+)")
	if itemid then
		return itemid.." - "..itemstring
	end --if
end --function

Consumable_Pets = {
"item:21301", --	Green Helper
"item:21305", --	Red Helper 
"item:21308", --  Jingling Bell (Raindeer)
"item:21309", --	Snowman
}


Rnd_Pets = {

-- The following 2 pets I kept forgetting to put in, Thanks for Adams in notifying me of this mistake

"item:33993",-- Mojo
"item:29960",-- Firefly (Keep flying!  up with the browncoats)

"item:35504", -- Phoenix Hatchling
"item:35350", -- Chuck's Bucket
"item:35349", -- Snarly's Bucket
"item:33818", -- Muckbreath's Bucket
"item:33816", -- Toothy's Bucket

"item:4401", --	Mechanical Squirrel 

"item:8485", --	Bombay
"item:8486", --	Cornish Rex
"item:8487", --	Orange Tabby
"item:8488", --	Silver Tabby 
"item:8489", --	White Kitten 

"item:8490", --	Siamese	
"item:8491", --	Black Tabby		

"item:8492", --	Green Wing Macaw 
"item:8494", --	Hyacinth Macaw 
"item:8495", --	Senegal
"item:8496", --	Cockatiel
"item:8497", -- Snowshoe Rabbit

"item:8498", --	Tiny Emerald Whelpling
"item:8499", --	Tiny Crimson Whelpling

"item:8500", --	Great Horned Owl
"item:8501", --	Hawk Owl 

"item:10360",	--	Black Kingsnake 
"item:10361",	--	Brown Snake 

"item:10392",	--	Crimson Snake 
"item:10393",	--	Cockroach

"item:10394",	--	Prairie Dog 
"item:10398",	--	Mechanical Chicken 

"item:10822", --  Dark Whelpling

"item:11023",	--	Ancona Chicken 
"item:11026",	--	Tree Frog -
"item:11027",	--	Wood Frog 

"item:11110", --  Chicken Egg

"item:11474", --  Sprite Darter Egg

"item:11825", --  Pet Bombling
"item:11826",	--	Lil' Smoky 

"item:12264", --  Worg Pup
"item:12529", --  Smolderweb Carrier

"item:15996", --	Lifelike Mechanical Toad

"item:19450", --	Jubling

"item:20769", --	Disgusting Oozeling

"item:21277", --	Tranquil Mechanical Yeti 
"item:21301", --	Green Helper
"item:21305", --	Red Helper 
"item:21308", --  Jingling Bell (Raindeer)
"item:21309", --	Snowman

"item:23002", --  Turtle Box for Speedy

"item:23713", --	Hippogryph Hatchling

-- Thanks to einZelkaeMpfer for these --
"item:20371", -- Blue Murloc Egg (Murky)

"item:23007", -- Piglet's Collar (Mr. Wiggles )

"item:23015", -- Rat Cage (Whiskers)
"item:13583", -- Panda Collar (Panda)

"item:13582", -- Zergling Leash
"item:13584", -- Diablo Stone (Mini Diablo)
"item:22114", -- Pink Murloc Egg = Gurky
-- End Thanks --
"item:29901", -- Blue Moth
"item:29902", -- Red Moth
"item:29903", -- Yellow Moth
"item:29904", -- White Moth
"item:25535", -- Netherwhelp - thanks arctae

"item:29958", -- Blue Dragon Hatchling
"item:29363", -- Mana Wyrmling
"item:31760", -- Miniwing (no idea what this one is) -- thanks JimBim, athos76
"item:23083", -- Cpatured Flame from Spirit of Summer -- thanks tiker
"item:29953", -- Golden Dragonhawk Hatchling -- thanks arctae
"item:29956", -- Red Dragonhawk Hatchling  - thanks arctae
"item:29957", -- Silver Dragonhawk Hatchling -- thanks arctae

"item:32233", -- Brewfest Drunk Pet

-- Orphan Quest in Shat alliance
"item:32622", -- Elekk Training Collar -- thanks tiker
"item:32616", -- Egbert's Egg -- thanks tiker
"item:32617", -- Sleepy Willy
	-- Blood Parrot
	-- Spirit of Summer
	-- Peddlefeet 
	 
	 -- 2.3 Patch
	"item:34478", -- Tiny Spore Bat
	"item:34535", -- Azure Whelpling
	"item:34425", -- Christmas Robot Pet
}
